unit motsmeles_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, Menus,
  Inifiles; //Fichier .ini;

const
  //Ini
  IniNom_ = 'MotsMeles.ini';
  //Couleurs
  ColJaune_ = $00D9F4FF;
  ColVertClair_ = $0082FF82;
  ColOrange_ = $00AFCEE2;
  ColVert_ = $009F9F00;
  ColRouge_ = $00A494FE;
  ColBleu_ = $00FFFFA6;
  ColBleu2_ = $00E1C1B9;
  ColCroisement_ = $00C9C1B8;
  ColBox_ = $00B9CFFF;
  ColGris_ = $00D4D4D4;
  //Taille Data
  Data3LMax_ = 1000;
  Data4LMax_ = 2500;
  Data5LMax_ = 6500;
  Data6LMax_ = 20000;
  Data7LMax_ = 44000;
  Data8LMax_ = 64000;
  Data9LMax_ = 75000;
  //Emplacements
  EmplXMax_ = 24;
  EmplYMax_ = 9;
  CasesXmax_ = 16;
  CasesYmax_ = 9;
  //Mots liste
  ListeMotsMax_ = 144;

type
  S001_ = string

    [1];
  S002_ = string

    [2];
  S003_ = string

    [3];
  S004_ = string

    [4];
  S005_ = string

    [5];
  S006_ = string

    [6];
  S007_ = string

    [7];
  S008_ = string

    [8];
  S009_ = string

    [9];
  S016_ = string

    [16];

  //Mots
  ListeMots_ = record
    //Mot : Sens 1 et 2
    LmMot1: S016_;
    LmMot2: S016_;
    //Orient. : 1:Hor. 2:Vert. 3:Diag. HB 4:Diag.BH
    LmOrient: integer;
    //Sens : 1 et 2
    LmSens: integer;
    //Nb Lettres
    LmNbLet: integer;
    //Coordonnée des points
    LmAffXd, LmAffYd: integer;
    LmAffXf, LmAffYf: integer;
    LmClicXd, LmClicYd: integer;
    LmClicXf, LmClicYf: integer;
    //Mot trouvé...
    LmOk: byte;
  end;

  SelectMem_ = record
    XY1: Tpoint;
    XY2: Tpoint;
    Col1: TColor;
    Col2: TColor;
  end;

type

  { TWdMain }

  TWdMain = class(TForm)
    CheckBox2: TCheckBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    PnSel1: TPanel;
    PnSel2: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Timer1: TTimer;
    x01y02: TPanel;
    x01y06: TPanel;
    x01y07: TPanel;
    x01y08: TPanel;
    x01y09: TPanel;
    x02y06: TPanel;
    x02y07: TPanel;
    x02y08: TPanel;
    x02y09: TPanel;
    x03y06: TPanel;
    x03y07: TPanel;
    x03y08: TPanel;
    x03y09: TPanel;
    x04y06: TPanel;
    x04y07: TPanel;
    x04y08: TPanel;
    x04y09: TPanel;
    x05y06: TPanel;
    x05y07: TPanel;
    x05y08: TPanel;
    x05y09: TPanel;
    x06y06: TPanel;
    x06y07: TPanel;
    x06y08: TPanel;
    x06y09: TPanel;
    x07y06: TPanel;
    x07y07: TPanel;
    x07y08: TPanel;
    x07y09: TPanel;
    x08y06: TPanel;
    x08y07: TPanel;
    x08y08: TPanel;
    x08y09: TPanel;
    x09y02: TPanel;
    x01y03: TPanel;
    x09y03: TPanel;
    x01y04: TPanel;
    x09y04: TPanel;
    x01y05: TPanel;
    x09y05: TPanel;
    x02y02: TPanel;
    x09y06: TPanel;
    x09y07: TPanel;
    x09y08: TPanel;
    x09y09: TPanel;
    x10y02: TPanel;
    x02y03: TPanel;
    x10y03: TPanel;
    x02y04: TPanel;
    x10y04: TPanel;
    x02y05: TPanel;
    x10y05: TPanel;
    x03y02: TPanel;
    x10y06: TPanel;
    x10y07: TPanel;
    x10y08: TPanel;
    x10y09: TPanel;
    x11y02: TPanel;
    x03y03: TPanel;
    x11y03: TPanel;
    x03y04: TPanel;
    x11y04: TPanel;
    x03y05: TPanel;
    x11y05: TPanel;
    x04y02: TPanel;
    x11y06: TPanel;
    x11y07: TPanel;
    x11y08: TPanel;
    x11y09: TPanel;
    x12y02: TPanel;
    x04y03: TPanel;
    x12y03: TPanel;
    x04y04: TPanel;
    x12y04: TPanel;
    x04y05: TPanel;
    x12y05: TPanel;
    x05y02: TPanel;
    x12y06: TPanel;
    x12y07: TPanel;
    x12y08: TPanel;
    x12y09: TPanel;
    x13y02: TPanel;
    x05y03: TPanel;
    x13y03: TPanel;
    x05y04: TPanel;
    x13y04: TPanel;
    x05y05: TPanel;
    x13y05: TPanel;
    x06y02: TPanel;
    x13y06: TPanel;
    x13y07: TPanel;
    x13y08: TPanel;
    x13y09: TPanel;
    x14y02: TPanel;
    x06y03: TPanel;
    x14y03: TPanel;
    x06y04: TPanel;
    x14y04: TPanel;
    x06y05: TPanel;
    x14y05: TPanel;
    x07y02: TPanel;
    x14y06: TPanel;
    x14y07: TPanel;
    x14y08: TPanel;
    x14y09: TPanel;
    x15y02: TPanel;
    x07y03: TPanel;
    x15y03: TPanel;
    x07y04: TPanel;
    x15y04: TPanel;
    x07y05: TPanel;
    x15y05: TPanel;
    x08y02: TPanel;
    x15y06: TPanel;
    x15y07: TPanel;
    x15y08: TPanel;
    x15y09: TPanel;
    x16y02: TPanel;
    x08y03: TPanel;
    x16y03: TPanel;
    x08y04: TPanel;
    x16y04: TPanel;
    x08y05: TPanel;
    x16y05: TPanel;
    x10y01: TPanel;
    x09y01: TPanel;
    x11y01: TPanel;
    x12y01: TPanel;
    x01y01: TPanel;
    x02y01: TPanel;
    x03y01: TPanel;
    x04y01: TPanel;
    x05y01: TPanel;
    x06y01: TPanel;
    x07y01: TPanel;
    x08y01: TPanel;
    x13y01: TPanel;
    x14y01: TPanel;
    x15y01: TPanel;
    x16y01: TPanel;
    x16y06: TPanel;
    x16y07: TPanel;
    x16y08: TPanel;
    x16y09: TPanel;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure x01y01Click(Sender: TObject);
    procedure x01y02Click(Sender: TObject);
    procedure x01y03Click(Sender: TObject);
    procedure x01y04Click(Sender: TObject);
    procedure x01y05Click(Sender: TObject);
    procedure x01y06Click(Sender: TObject);
    procedure x01y07Click(Sender: TObject);
    procedure x01y08Click(Sender: TObject);
    procedure x01y09Click(Sender: TObject);
    procedure x02y01Click(Sender: TObject);
    procedure x02y02Click(Sender: TObject);
    procedure x02y03Click(Sender: TObject);
    procedure x02y04Click(Sender: TObject);
    procedure x02y05Click(Sender: TObject);
    procedure x02y06Click(Sender: TObject);
    procedure x02y07Click(Sender: TObject);
    procedure x02y08Click(Sender: TObject);
    procedure x02y09Click(Sender: TObject);
    procedure x03y01Click(Sender: TObject);
    procedure x03y02Click(Sender: TObject);
    procedure x03y03Click(Sender: TObject);
    procedure x03y04Click(Sender: TObject);
    procedure x03y05Click(Sender: TObject);
    procedure x03y06Click(Sender: TObject);
    procedure x03y07Click(Sender: TObject);
    procedure x03y08Click(Sender: TObject);
    procedure x03y09Click(Sender: TObject);
    procedure x04y01Click(Sender: TObject);
    procedure x04y02Click(Sender: TObject);
    procedure x04y03Click(Sender: TObject);
    procedure x04y04Click(Sender: TObject);
    procedure x04y05Click(Sender: TObject);
    procedure x04y06Click(Sender: TObject);
    procedure x04y07Click(Sender: TObject);
    procedure x04y08Click(Sender: TObject);
    procedure x04y09Click(Sender: TObject);
    procedure x05y01Click(Sender: TObject);
    procedure x05y02Click(Sender: TObject);
    procedure x05y03Click(Sender: TObject);
    procedure x05y04Click(Sender: TObject);
    procedure x05y05Click(Sender: TObject);
    procedure x05y06Click(Sender: TObject);
    procedure x05y07Click(Sender: TObject);
    procedure x05y08Click(Sender: TObject);
    procedure x05y09Click(Sender: TObject);
    procedure x06y01Click(Sender: TObject);
    procedure x06y02Click(Sender: TObject);
    procedure x06y03Click(Sender: TObject);
    procedure x06y04Click(Sender: TObject);
    procedure x06y05Click(Sender: TObject);
    procedure x06y06Click(Sender: TObject);
    procedure x06y07Click(Sender: TObject);
    procedure x06y08Click(Sender: TObject);
    procedure x06y09Click(Sender: TObject);
    procedure x07y01Click(Sender: TObject);
    procedure x07y02Click(Sender: TObject);
    procedure x07y03Click(Sender: TObject);
    procedure x07y04Click(Sender: TObject);
    procedure x07y05Click(Sender: TObject);
    procedure x07y06Click(Sender: TObject);
    procedure x07y07Click(Sender: TObject);
    procedure x07y08Click(Sender: TObject);
    procedure x07y09Click(Sender: TObject);
    procedure x08y01Click(Sender: TObject);
    procedure x08y02Click(Sender: TObject);
    procedure x08y03Click(Sender: TObject);
    procedure x08y04Click(Sender: TObject);
    procedure x08y05Click(Sender: TObject);
    procedure x08y06Click(Sender: TObject);
    procedure x08y07Click(Sender: TObject);
    procedure x08y08Click(Sender: TObject);
    procedure x08y09Click(Sender: TObject);
    procedure x09y01Click(Sender: TObject);
    procedure x09y02Click(Sender: TObject);
    procedure x09y03Click(Sender: TObject);
    procedure x09y04Click(Sender: TObject);
    procedure x09y05Click(Sender: TObject);
    procedure x09y06Click(Sender: TObject);
    procedure x09y07Click(Sender: TObject);
    procedure x09y08Click(Sender: TObject);
    procedure x09y09Click(Sender: TObject);
    procedure x10y01Click(Sender: TObject);
    procedure x10y02Click(Sender: TObject);
    procedure x10y03Click(Sender: TObject);
    procedure x10y04Click(Sender: TObject);
    procedure x10y05Click(Sender: TObject);
    procedure x10y06Click(Sender: TObject);
    procedure x10y07Click(Sender: TObject);
    procedure x10y08Click(Sender: TObject);
    procedure x10y09Click(Sender: TObject);
    procedure x11y01Click(Sender: TObject);
    procedure x11y02Click(Sender: TObject);
    procedure x11y03Click(Sender: TObject);
    procedure x11y04Click(Sender: TObject);
    procedure x11y05Click(Sender: TObject);
    procedure x11y06Click(Sender: TObject);
    procedure x11y07Click(Sender: TObject);
    procedure x11y08Click(Sender: TObject);
    procedure x11y09Click(Sender: TObject);
    procedure x12y01Click(Sender: TObject);
    procedure x12y02Click(Sender: TObject);
    procedure x12y03Click(Sender: TObject);
    procedure x12y04Click(Sender: TObject);
    procedure x12y05Click(Sender: TObject);
    procedure x12y06Click(Sender: TObject);
    procedure x12y07Click(Sender: TObject);
    procedure x12y08Click(Sender: TObject);
    procedure x12y09Click(Sender: TObject);
    procedure x13y01Click(Sender: TObject);
    procedure x13y02Click(Sender: TObject);
    procedure x13y03Click(Sender: TObject);
    procedure x13y04Click(Sender: TObject);
    procedure x13y05Click(Sender: TObject);
    procedure x13y06Click(Sender: TObject);
    procedure x13y07Click(Sender: TObject);
    procedure x13y08Click(Sender: TObject);
    procedure x13y09Click(Sender: TObject);
    procedure x14y01Click(Sender: TObject);
    procedure x14y02Click(Sender: TObject);
    procedure x14y03Click(Sender: TObject);
    procedure x14y04Click(Sender: TObject);
    procedure x14y05Click(Sender: TObject);
    procedure x14y06Click(Sender: TObject);
    procedure x14y07Click(Sender: TObject);
    procedure x14y08Click(Sender: TObject);
    procedure x14y09Click(Sender: TObject);
    procedure x15y01Click(Sender: TObject);
    procedure x15y02Click(Sender: TObject);
    procedure x15y03Click(Sender: TObject);
    procedure x15y04Click(Sender: TObject);
    procedure x15y05Click(Sender: TObject);
    procedure x15y06Click(Sender: TObject);
    procedure x15y07Click(Sender: TObject);
    procedure x15y08Click(Sender: TObject);
    procedure x15y09Click(Sender: TObject);
    procedure x16y01Click(Sender: TObject);
    procedure x16y02Click(Sender: TObject);
    procedure x16y03Click(Sender: TObject);
    procedure x16y04Click(Sender: TObject);
    procedure x16y05Click(Sender: TObject);
    procedure x16y06Click(Sender: TObject);
    procedure x16y07Click(Sender: TObject);
    procedure x16y08Click(Sender: TObject);
    procedure x16y09Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;
  DirExe: string;

implementation

{$R *.lfm}

{ TWdMain }

var
  //----- Data -----
  fFil3L: file of S003_;
  fFil4L: file of S004_;
  fFil5L: file of S005_;
  fFil6L: file of S006_;
  fFil7L: file of S007_;
  fFil8L: file of S008_;
  fFil9L: file of S009_;
  //Data
  Data3L: array[1..Data3LMax_] of S003_;
  Data4L: array[1..Data4LMax_] of S004_;
  Data5L: array[1..Data5LMax_] of S005_;
  Data6L: array[1..Data6LMax_] of S006_;
  Data7L: array[1..Data7LMax_] of S007_;
  Data8L: array[1..Data8LMax_] of S008_;
  Data9L: array[1..Data9LMax_] of S009_;
  //----- Liste des emplacements possibles-----
  ListeMots: array[1..ListeMotsMax_] of ListeMots_;
  //----- Liste Mots -----
  ListeMotsNb: integer;
  ListeMotsNbMax: integer;
  //Selection
  SelectMem: SelectMem_;
  //-
  //Max
  DataTaille3L: integer;
  DataTaille4L: integer;
  DataTaille5L: integer;
  DataTaille6L: integer;
  DataTaille7L: integer;
  DataTaille8L: integer;
  DataTaille9L: integer;
  //Data
  Data: array[1..CasesXmax_, 1..CasesYmax_] of S001_;
  DataEmplH: array[1..CasesXmax_, 1..CasesYmax_] of integer;
  DataEmplV: array[1..CasesXmax_, 1..CasesYmax_] of integer;
  DataEmplDHB: array[1..EmplXMax_, 1..EmplYMax_] of integer;
  DataEmplDBH: array[1..EmplXMax_, 1..EmplYMax_] of integer;
  //Selection
  Sel1, Sel2: Tpoint;
  //Chrono
  HeureDeDepart: TDateTime;
  HeureArrivee: TDateTime;
  Stop: boolean = False;

function Alea(Max: integer): integer;
var
  r, rd: integer;
begin
  Rd := 0;
  repeat
    r := Random(Max) + 1;
    Inc(Rd);
  until rd > 20000;
  Result := r;
end;

function AleaDB(Debut, Fin: integer): integer;
var
  n, r: integer;
begin
  repeat
    n := 0;
    repeat
      r := Random(Fin) + 1;
      Inc(n);
    until n > 5000;
  until r in [Debut..Fin];
  Result := r;
end;

procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
begin
  with WdMain do
  begin
    Fichier := DirExe + IniNom_;
    if FileExists(Fichier) then
      with WdMain do
      begin
        FIni := TiniFile.Create(Fichier);
        //----- Option case en couleur ou en gris -----
        WdMain.CheckBox2.Checked := FIni.ReadBool('Couleur', 'Gris', False);
        Fini.Free;
      end;
  end;
end;

procedure Ini_Sauve;
var
  FIni: TiniFile;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirExe + IniNom_);
    //----- Option case en couleur ou en gris -----
    if CheckBox2.Checked then
      FIni.WriteBool('Couleur', 'Gris', True)
    else
      FIni.WriteBool('Couleur', 'Gris', False);
    Fini.Free;
  end;
end;

procedure Color_to_Panel(x, y: integer; Col: TColor);
begin
  with WdMain do
  begin
    case x of
      1: case y of
          1: x01y01.Color := Col;
          2: x01y02.Color := Col;
          3: x01y03.Color := Col;
          4: x01y04.Color := Col;
          5: x01y05.Color := Col;
          6: x01y06.Color := Col;
          7: x01y07.Color := Col;
          8: x01y08.Color := Col;
          9: x01y09.Color := Col;
        end;
      2: case y of
          1: x02y01.Color := Col;
          2: x02y02.Color := Col;
          3: x02y03.Color := Col;
          4: x02y04.Color := Col;
          5: x02y05.Color := Col;
          6: x02y06.Color := Col;
          7: x02y07.Color := Col;
          8: x02y08.Color := Col;
          9: x02y09.Color := Col;
        end;
      3: case y of
          1: x03y01.Color := Col;
          2: x03y02.Color := Col;
          3: x03y03.Color := Col;
          4: x03y04.Color := Col;
          5: x03y05.Color := Col;
          6: x03y06.Color := Col;
          7: x03y07.Color := Col;
          8: x03y08.Color := Col;
          9: x03y09.Color := Col;
        end;
      4: case y of
          1: x04y01.Color := Col;
          2: x04y02.Color := Col;
          3: x04y03.Color := Col;
          4: x04y04.Color := Col;
          5: x04y05.Color := Col;
          6: x04y06.Color := Col;
          7: x04y07.Color := Col;
          8: x04y08.Color := Col;
          9: x04y09.Color := Col;
        end;
      5: case y of
          1: x05y01.Color := Col;
          2: x05y02.Color := Col;
          3: x05y03.Color := Col;
          4: x05y04.Color := Col;
          5: x05y05.Color := Col;
          6: x05y06.Color := Col;
          7: x05y07.Color := Col;
          8: x05y08.Color := Col;
          9: x05y09.Color := Col;
        end;
      6: case y of
          1: x06y01.Color := Col;
          2: x06y02.Color := Col;
          3: x06y03.Color := Col;
          4: x06y04.Color := Col;
          5: x06y05.Color := Col;
          6: x06y06.Color := Col;
          7: x06y07.Color := Col;
          8: x06y08.Color := Col;
          9: x06y09.Color := Col;
        end;
      7: case y of
          1: x07y01.Color := Col;
          2: x07y02.Color := Col;
          3: x07y03.Color := Col;
          4: x07y04.Color := Col;
          5: x07y05.Color := Col;
          6: x07y06.Color := Col;
          7: x07y07.Color := Col;
          8: x07y08.Color := Col;
          9: x07y09.Color := Col;
        end;
      8: case y of
          1: x08y01.Color := Col;
          2: x08y02.Color := Col;
          3: x08y03.Color := Col;
          4: x08y04.Color := Col;
          5: x08y05.Color := Col;
          6: x08y06.Color := Col;
          7: x08y07.Color := Col;
          8: x08y08.Color := Col;
          9: x08y09.Color := Col;
        end;
      9: case y of
          1: x09y01.Color := Col;
          2: x09y02.Color := Col;
          3: x09y03.Color := Col;
          4: x09y04.Color := Col;
          5: x09y05.Color := Col;
          6: x09y06.Color := Col;
          7: x09y07.Color := Col;
          8: x09y08.Color := Col;
          9: x09y09.Color := Col;
        end;
      10: case y of
          1: x10y01.Color := Col;
          2: x10y02.Color := Col;
          3: x10y03.Color := Col;
          4: x10y04.Color := Col;
          5: x10y05.Color := Col;
          6: x10y06.Color := Col;
          7: x10y07.Color := Col;
          8: x10y08.Color := Col;
          9: x10y09.Color := Col;
        end;
      11: case y of
          1: x11y01.Color := Col;
          2: x11y02.Color := Col;
          3: x11y03.Color := Col;
          4: x11y04.Color := Col;
          5: x11y05.Color := Col;
          6: x11y06.Color := Col;
          7: x11y07.Color := Col;
          8: x11y08.Color := Col;
          9: x11y09.Color := Col;
        end;
      12: case y of
          1: x12y01.Color := Col;
          2: x12y02.Color := Col;
          3: x12y03.Color := Col;
          4: x12y04.Color := Col;
          5: x12y05.Color := Col;
          6: x12y06.Color := Col;
          7: x12y07.Color := Col;
          8: x12y08.Color := Col;
          9: x12y09.Color := Col;
        end;
      13: case y of
          1: x13y01.Color := Col;
          2: x13y02.Color := Col;
          3: x13y03.Color := Col;
          4: x13y04.Color := Col;
          5: x13y05.Color := Col;
          6: x13y06.Color := Col;
          7: x13y07.Color := Col;
          8: x13y08.Color := Col;
          9: x13y09.Color := Col;
        end;
      14: case y of
          1: x14y01.Color := Col;
          2: x14y02.Color := Col;
          3: x14y03.Color := Col;
          4: x14y04.Color := Col;
          5: x14y05.Color := Col;
          6: x14y06.Color := Col;
          7: x14y07.Color := Col;
          8: x14y08.Color := Col;
          9: x14y09.Color := Col;
        end;
      15: case y of
          1: x15y01.Color := Col;
          2: x15y02.Color := Col;
          3: x15y03.Color := Col;
          4: x15y04.Color := Col;
          5: x15y05.Color := Col;
          6: x15y06.Color := Col;
          7: x15y07.Color := Col;
          8: x15y08.Color := Col;
          9: x15y09.Color := Col;
        end;
      16: case y of
          1: x16y01.Color := Col;
          2: x16y02.Color := Col;
          3: x16y03.Color := Col;
          4: x16y04.Color := Col;
          5: x16y05.Color := Col;
          6: x16y06.Color := Col;
          7: x16y07.Color := Col;
          8: x16y08.Color := Col;
          9: x16y09.Color := Col;
        end;
    end;
  end;
end;

//Couleur pour les Orient. des Mots
procedure Color_to_Panel2(x, y, Orient: integer; OnOff: byte);
var
  Col: Tcolor;
begin
  with WdMain do
  begin
    case OnOff of
      //Eteindre
      0: Col := ColJaune_;
      //Allumer
      1: case Orient of
          0: Col := ColVert_;
          1: Col := ColRouge_;
          2: Col := ColBleu_;
          3: Col := ColVertClair_;
          4: Col := ClYellow;
        end;
    end;
    case x of
      1: case y of
          1: x01y01.Color := Col;
          2: x01y02.Color := Col;
          3: x01y03.Color := Col;
          4: x01y04.Color := Col;
          5: x01y05.Color := Col;
          6: x01y06.Color := Col;
          7: x01y07.Color := Col;
          8: x01y08.Color := Col;
          9: x01y09.Color := Col;
        end;
      2: case y of
          1: x02y01.Color := Col;
          2: x02y02.Color := Col;
          3: x02y03.Color := Col;
          4: x02y04.Color := Col;
          5: x02y05.Color := Col;
          6: x02y06.Color := Col;
          7: x02y07.Color := Col;
          8: x02y08.Color := Col;
          9: x02y09.Color := Col;
        end;
      3: case y of
          1: x03y01.Color := Col;
          2: x03y02.Color := Col;
          3: x03y03.Color := Col;
          4: x03y04.Color := Col;
          5: x03y05.Color := Col;
          6: x03y06.Color := Col;
          7: x03y07.Color := Col;
          8: x03y08.Color := Col;
          9: x03y09.Color := Col;
        end;
      4: case y of
          1: x04y01.Color := Col;
          2: x04y02.Color := Col;
          3: x04y03.Color := Col;
          4: x04y04.Color := Col;
          5: x04y05.Color := Col;
          6: x04y06.Color := Col;
          7: x04y07.Color := Col;
          8: x04y08.Color := Col;
          9: x04y09.Color := Col;
        end;
      5: case y of
          1: x05y01.Color := Col;
          2: x05y02.Color := Col;
          3: x05y03.Color := Col;
          4: x05y04.Color := Col;
          5: x05y05.Color := Col;
          6: x05y06.Color := Col;
          7: x05y07.Color := Col;
          8: x05y08.Color := Col;
          9: x05y09.Color := Col;
        end;
      6: case y of
          1: x06y01.Color := Col;
          2: x06y02.Color := Col;
          3: x06y03.Color := Col;
          4: x06y04.Color := Col;
          5: x06y05.Color := Col;
          6: x06y06.Color := Col;
          7: x06y07.Color := Col;
          8: x06y08.Color := Col;
          9: x06y09.Color := Col;
        end;
      7: case y of
          1: x07y01.Color := Col;
          2: x07y02.Color := Col;
          3: x07y03.Color := Col;
          4: x07y04.Color := Col;
          5: x07y05.Color := Col;
          6: x07y06.Color := Col;
          7: x07y07.Color := Col;
          8: x07y08.Color := Col;
          9: x07y09.Color := Col;
        end;
      8: case y of
          1: x08y01.Color := Col;
          2: x08y02.Color := Col;
          3: x08y03.Color := Col;
          4: x08y04.Color := Col;
          5: x08y05.Color := Col;
          6: x08y06.Color := Col;
          7: x08y07.Color := Col;
          8: x08y08.Color := Col;
          9: x08y09.Color := Col;
        end;
      9: case y of
          1: x09y01.Color := Col;
          2: x09y02.Color := Col;
          3: x09y03.Color := Col;
          4: x09y04.Color := Col;
          5: x09y05.Color := Col;
          6: x09y06.Color := Col;
          7: x09y07.Color := Col;
          8: x09y08.Color := Col;
          9: x09y09.Color := Col;
        end;
      10: case y of
          1: x10y01.Color := Col;
          2: x10y02.Color := Col;
          3: x10y03.Color := Col;
          4: x10y04.Color := Col;
          5: x10y05.Color := Col;
          6: x10y06.Color := Col;
          7: x10y07.Color := Col;
          8: x10y08.Color := Col;
          9: x10y09.Color := Col;
        end;
      11: case y of
          1: x11y01.Color := Col;
          2: x11y02.Color := Col;
          3: x11y03.Color := Col;
          4: x11y04.Color := Col;
          5: x11y05.Color := Col;
          6: x11y06.Color := Col;
          7: x11y07.Color := Col;
          8: x11y08.Color := Col;
          9: x11y09.Color := Col;
        end;
      12: case y of
          1: x12y01.Color := Col;
          2: x12y02.Color := Col;
          3: x12y03.Color := Col;
          4: x12y04.Color := Col;
          5: x12y05.Color := Col;
          6: x12y06.Color := Col;
          7: x12y07.Color := Col;
          8: x12y08.Color := Col;
          9: x12y09.Color := Col;
        end;
      13: case y of
          1: x13y01.Color := Col;
          2: x13y02.Color := Col;
          3: x13y03.Color := Col;
          4: x13y04.Color := Col;
          5: x13y05.Color := Col;
          6: x13y06.Color := Col;
          7: x13y07.Color := Col;
          8: x13y08.Color := Col;
          9: x13y09.Color := Col;
        end;
      14: case y of
          1: x14y01.Color := Col;
          2: x14y02.Color := Col;
          3: x14y03.Color := Col;
          4: x14y04.Color := Col;
          5: x14y05.Color := Col;
          6: x14y06.Color := Col;
          7: x14y07.Color := Col;
          8: x14y08.Color := Col;
          9: x14y09.Color := Col;
        end;
      15: case y of
          1: x15y01.Color := Col;
          2: x15y02.Color := Col;
          3: x15y03.Color := Col;
          4: x15y04.Color := Col;
          5: x15y05.Color := Col;
          6: x15y06.Color := Col;
          7: x15y07.Color := Col;
          8: x15y08.Color := Col;
          9: x15y09.Color := Col;
        end;
      16: case y of
          1: x16y01.Color := Col;
          2: x16y02.Color := Col;
          3: x16y03.Color := Col;
          4: x16y04.Color := Col;
          5: x16y05.Color := Col;
          6: x16y06.Color := Col;
          7: x16y07.Color := Col;
          8: x16y08.Color := Col;
          9: x16y09.Color := Col;
        end;
    end;
  end;
end;

function Panel_to_Color(x, y: integer): TColor;
var
  Col: Tcolor;
begin
  with WdMain do
  begin
    Col := 0;
    case x of
      1: case y of
          1: Col := x01y01.Color;
          2: Col := x01y02.Color;
          3: Col := x01y03.Color;
          4: Col := x01y04.Color;
          5: Col := x01y05.Color;
          6: Col := x01y06.Color;
          7: Col := x01y07.Color;
          8: Col := x01y08.Color;
          9: Col := x01y09.Color;
        end;
      2: case y of
          1: Col := x02y01.Color;
          2: Col := x02y02.Color;
          3: Col := x02y03.Color;
          4: Col := x02y04.Color;
          5: Col := x02y05.Color;
          6: Col := x02y06.Color;
          7: Col := x02y07.Color;
          8: Col := x02y08.Color;
          9: Col := x02y09.Color;
        end;
      3: case y of
          1: Col := x03y01.Color;
          2: Col := x03y02.Color;
          3: Col := x03y03.Color;
          4: Col := x03y04.Color;
          5: Col := x03y05.Color;
          6: Col := x03y06.Color;
          7: Col := x03y07.Color;
          8: Col := x03y08.Color;
          9: Col := x03y09.Color;
        end;
      4: case y of
          1: Col := x04y01.Color;
          2: Col := x04y02.Color;
          3: Col := x04y03.Color;
          4: Col := x04y04.Color;
          5: Col := x04y05.Color;
          6: Col := x04y06.Color;
          7: Col := x04y07.Color;
          8: Col := x04y08.Color;
          9: Col := x04y09.Color;
        end;
      5: case y of
          1: Col := x05y01.Color;
          2: Col := x05y02.Color;
          3: Col := x05y03.Color;
          4: Col := x05y04.Color;
          5: Col := x05y05.Color;
          6: Col := x05y06.Color;
          7: Col := x05y07.Color;
          8: Col := x05y08.Color;
          9: Col := x05y09.Color;
        end;
      6: case y of
          1: Col := x06y01.Color;
          2: Col := x06y02.Color;
          3: Col := x06y03.Color;
          4: Col := x06y04.Color;
          5: Col := x06y05.Color;
          6: Col := x06y06.Color;
          7: Col := x06y07.Color;
          8: Col := x06y08.Color;
          9: Col := x06y09.Color;
        end;
      7: case y of
          1: Col := x07y01.Color;
          2: Col := x07y02.Color;
          3: Col := x07y03.Color;
          4: Col := x07y04.Color;
          5: Col := x07y05.Color;
          6: Col := x07y06.Color;
          7: Col := x07y07.Color;
          8: Col := x07y08.Color;
          9: Col := x07y09.Color;
        end;
      8: case y of
          1: Col := x08y01.Color;
          2: Col := x08y02.Color;
          3: Col := x08y03.Color;
          4: Col := x08y04.Color;
          5: Col := x08y05.Color;
          6: Col := x08y06.Color;
          7: Col := x08y07.Color;
          8: Col := x08y08.Color;
          9: Col := x08y09.Color;
        end;
      9: case y of
          1: Col := x09y01.Color;
          2: Col := x09y02.Color;
          3: Col := x09y03.Color;
          4: Col := x09y04.Color;
          5: Col := x09y05.Color;
          6: Col := x09y06.Color;
          7: Col := x09y07.Color;
          8: Col := x09y08.Color;
          9: Col := x09y09.Color;
        end;
      10: case y of
          1: Col := x10y01.Color;
          2: Col := x10y02.Color;
          3: Col := x10y03.Color;
          4: Col := x10y04.Color;
          5: Col := x10y05.Color;
          6: Col := x10y06.Color;
          7: Col := x10y07.Color;
          8: Col := x10y08.Color;
          9: Col := x10y09.Color;
        end;
      11: case y of
          1: Col := x11y01.Color;
          2: Col := x11y02.Color;
          3: Col := x11y03.Color;
          4: Col := x11y04.Color;
          5: Col := x11y05.Color;
          6: Col := x11y06.Color;
          7: Col := x11y07.Color;
          8: Col := x11y08.Color;
          9: Col := x11y09.Color;
        end;
      12: case y of
          1: Col := x12y01.Color;
          2: Col := x12y02.Color;
          3: Col := x12y03.Color;
          4: Col := x12y04.Color;
          5: Col := x12y05.Color;
          6: Col := x12y06.Color;
          7: Col := x12y07.Color;
          8: Col := x12y08.Color;
          9: Col := x12y09.Color;
        end;
      13: case y of
          1: Col := x13y01.Color;
          2: Col := x13y02.Color;
          3: Col := x13y03.Color;
          4: Col := x13y04.Color;
          5: Col := x13y05.Color;
          6: Col := x13y06.Color;
          7: Col := x13y07.Color;
          8: Col := x13y08.Color;
          9: Col := x13y09.Color;
        end;
      14: case y of
          1: Col := x14y01.Color;
          2: Col := x14y02.Color;
          3: Col := x14y03.Color;
          4: Col := x14y04.Color;
          5: Col := x14y05.Color;
          6: Col := x14y06.Color;
          7: Col := x14y07.Color;
          8: Col := x14y08.Color;
          9: Col := x14y09.Color;
        end;
      15: case y of
          1: Col := x15y01.Color;
          2: Col := x15y02.Color;
          3: Col := x15y03.Color;
          4: Col := x15y04.Color;
          5: Col := x15y05.Color;
          6: Col := x15y06.Color;
          7: Col := x15y07.Color;
          8: Col := x15y08.Color;
          9: Col := x15y09.Color;
        end;
      16: case y of
          1: Col := x16y01.Color;
          2: Col := x16y02.Color;
          3: Col := x16y03.Color;
          4: Col := x16y04.Color;
          5: Col := x16y05.Color;
          6: Col := x16y06.Color;
          7: Col := x16y07.Color;
          8: Col := x16y08.Color;
          9: Col := x16y09.Color;
        end;
    end;
    Result := Col;
  end;
end;

procedure ColorAll_to_Panel(Emplacement: integer);
var
  Col, ColF: TColor;
  n, x, y: integer;
begin
  with WdMain do
  begin
    with ListeMots[Emplacement] do
    begin
      if CheckBox2.Checked then
      begin
        Col := ColCroisement_;
      end
      else
      begin
        case LmOrient of
          1: Col := ColRouge_;
          2: Col := ColBleu_;
          3: Col := ColVertClair_;
          4: Col := ClYellow;
          else
            Col := ColJaune_;
        end;
      end;
      case LmOrient of
        //Horizontal
        1: for n := 1 to LmNbLet do
          begin
            x := LmAffXd + n - 1;
            y := LmAffYd;
            ColF := Panel_to_Color(x, y);
            if (ColF <> ColJaune_) and (ColF <> ColVert_) then
              Color_to_Panel(x, y, ColCroisement_)
            else
              Color_to_Panel(x, y, Col);
          end;
        //Vertical
        2: for n := 1 to LmNbLet do
          begin
            x := LmAffXd;
            y := LmAffYd + n - 1;
            ColF := Panel_to_Color(x, y);
            if (ColF <> ColJaune_) and (ColF <> ColVert_) then
              Color_to_Panel(x, y, ColCroisement_)
            else
              Color_to_Panel(x, y, Col);
          end;
        //Diagonal HG
        3: for n := 1 to LmNbLet do
          begin
            x := LmAffXd + n - 1;
            y := LmAffYd + n - 1;
            ColF := Panel_to_Color(x, y);
            if (ColF <> ColJaune_) and (ColF <> ColVert_) then
              Color_to_Panel(x, y, ColCroisement_)
            else
              Color_to_Panel(x, y, Col);
          end;
        //Diagonal HD
        4: for n := 1 to LmNbLet do
          begin
            x := LmAffXd - n + 1;
            y := LmAffYd + n - 1;
            ColF := Panel_to_Color(x, y);
            if (ColF <> ColJaune_) and (ColF <> ColVert_) then
              Color_to_Panel(x, y, ColCroisement_)
            else
              Color_to_Panel(x, y, Col);
          end;
      end;
    end;
  end;
end;

procedure Str_to_Panel(x, y: integer; s: string);
begin
  with WdMain do
  begin
    case x of
      1: case y of
          1: x01y01.Caption := s;
          2: x01y02.Caption := s;
          3: x01y03.Caption := s;
          4: x01y04.Caption := s;
          5: x01y05.Caption := s;
          6: x01y06.Caption := s;
          7: x01y07.Caption := s;
          8: x01y08.Caption := s;
          9: x01y09.Caption := s;
        end;
      2: case y of
          1: x02y01.Caption := s;
          2: x02y02.Caption := s;
          3: x02y03.Caption := s;
          4: x02y04.Caption := s;
          5: x02y05.Caption := s;
          6: x02y06.Caption := s;
          7: x02y07.Caption := s;
          8: x02y08.Caption := s;
          9: x02y09.Caption := s;
        end;
      3: case y of
          1: x03y01.Caption := s;
          2: x03y02.Caption := s;
          3: x03y03.Caption := s;
          4: x03y04.Caption := s;
          5: x03y05.Caption := s;
          6: x03y06.Caption := s;
          7: x03y07.Caption := s;
          8: x03y08.Caption := s;
          9: x03y09.Caption := s;
        end;
      4: case y of
          1: x04y01.Caption := s;
          2: x04y02.Caption := s;
          3: x04y03.Caption := s;
          4: x04y04.Caption := s;
          5: x04y05.Caption := s;
          6: x04y06.Caption := s;
          7: x04y07.Caption := s;
          8: x04y08.Caption := s;
          9: x04y09.Caption := s;
        end;
      5: case y of
          1: x05y01.Caption := s;
          2: x05y02.Caption := s;
          3: x05y03.Caption := s;
          4: x05y04.Caption := s;
          5: x05y05.Caption := s;
          6: x05y06.Caption := s;
          7: x05y07.Caption := s;
          8: x05y08.Caption := s;
          9: x05y09.Caption := s;
        end;
      6: case y of
          1: x06y01.Caption := s;
          2: x06y02.Caption := s;
          3: x06y03.Caption := s;
          4: x06y04.Caption := s;
          5: x06y05.Caption := s;
          6: x06y06.Caption := s;
          7: x06y07.Caption := s;
          8: x06y08.Caption := s;
          9: x06y09.Caption := s;
        end;
      7: case y of
          1: x07y01.Caption := s;
          2: x07y02.Caption := s;
          3: x07y03.Caption := s;
          4: x07y04.Caption := s;
          5: x07y05.Caption := s;
          6: x07y06.Caption := s;
          7: x07y07.Caption := s;
          8: x07y08.Caption := s;
          9: x07y09.Caption := s;
        end;
      8: case y of
          1: x08y01.Caption := s;
          2: x08y02.Caption := s;
          3: x08y03.Caption := s;
          4: x08y04.Caption := s;
          5: x08y05.Caption := s;
          6: x08y06.Caption := s;
          7: x08y07.Caption := s;
          8: x08y08.Caption := s;
          9: x08y09.Caption := s;
        end;
      9: case y of
          1: x09y01.Caption := s;
          2: x09y02.Caption := s;
          3: x09y03.Caption := s;
          4: x09y04.Caption := s;
          5: x09y05.Caption := s;
          6: x09y06.Caption := s;
          7: x09y07.Caption := s;
          8: x09y08.Caption := s;
          9: x09y09.Caption := s;
        end;
      10: case y of
          1: x10y01.Caption := s;
          2: x10y02.Caption := s;
          3: x10y03.Caption := s;
          4: x10y04.Caption := s;
          5: x10y05.Caption := s;
          6: x10y06.Caption := s;
          7: x10y07.Caption := s;
          8: x10y08.Caption := s;
          9: x10y09.Caption := s;
        end;
      11: case y of
          1: x11y01.Caption := s;
          2: x11y02.Caption := s;
          3: x11y03.Caption := s;
          4: x11y04.Caption := s;
          5: x11y05.Caption := s;
          6: x11y06.Caption := s;
          7: x11y07.Caption := s;
          8: x11y08.Caption := s;
          9: x11y09.Caption := s;
        end;
      12: case y of
          1: x12y01.Caption := s;
          2: x12y02.Caption := s;
          3: x12y03.Caption := s;
          4: x12y04.Caption := s;
          5: x12y05.Caption := s;
          6: x12y06.Caption := s;
          7: x12y07.Caption := s;
          8: x12y08.Caption := s;
          9: x12y09.Caption := s;
        end;
      13: case y of
          1: x13y01.Caption := s;
          2: x13y02.Caption := s;
          3: x13y03.Caption := s;
          4: x13y04.Caption := s;
          5: x13y05.Caption := s;
          6: x13y06.Caption := s;
          7: x13y07.Caption := s;
          8: x13y08.Caption := s;
          9: x13y09.Caption := s;
        end;
      14: case y of
          1: x14y01.Caption := s;
          2: x14y02.Caption := s;
          3: x14y03.Caption := s;
          4: x14y04.Caption := s;
          5: x14y05.Caption := s;
          6: x14y06.Caption := s;
          7: x14y07.Caption := s;
          8: x14y08.Caption := s;
          9: x14y09.Caption := s;
        end;
      15: case y of
          1: x15y01.Caption := s;
          2: x15y02.Caption := s;
          3: x15y03.Caption := s;
          4: x15y04.Caption := s;
          5: x15y05.Caption := s;
          6: x15y06.Caption := s;
          7: x15y07.Caption := s;
          8: x15y08.Caption := s;
          9: x15y09.Caption := s;
        end;
      16: case y of
          1: x16y01.Caption := s;
          2: x16y02.Caption := s;
          3: x16y03.Caption := s;
          4: x16y04.Caption := s;
          5: x16y05.Caption := s;
          6: x16y06.Caption := s;
          7: x16y07.Caption := s;
          8: x16y08.Caption := s;
          9: x16y09.Caption := s;
        end;
    end;
  end;
end;

function Panel_to_Str(x, y: integer): string;
var
  s: string;
begin
  with WdMain do
  begin
    case x of
      1: case y of
          1: s := x01y01.Caption;
          2: s := x01y02.Caption;
          3: s := x01y03.Caption;
          4: s := x01y04.Caption;
          5: s := x01y05.Caption;
          6: s := x01y06.Caption;
          7: s := x01y07.Caption;
          8: s := x01y08.Caption;
          9: s := x01y09.Caption;
        end;
      2: case y of
          1: s := x02y01.Caption;
          2: s := x02y02.Caption;
          3: s := x02y03.Caption;
          4: s := x02y04.Caption;
          5: s := x02y05.Caption;
          6: s := x02y06.Caption;
          7: s := x02y07.Caption;
          8: s := x02y08.Caption;
          9: s := x02y09.Caption;
        end;
      3: case y of
          1: s := x03y01.Caption;
          2: s := x03y02.Caption;
          3: s := x03y03.Caption;
          4: s := x03y04.Caption;
          5: s := x03y05.Caption;
          6: s := x03y06.Caption;
          7: s := x03y07.Caption;
          8: s := x03y08.Caption;
          9: s := x03y09.Caption;
        end;
      4: case y of
          1: s := x04y01.Caption;
          2: s := x04y02.Caption;
          3: s := x04y03.Caption;
          4: s := x04y04.Caption;
          5: s := x04y05.Caption;
          6: s := x04y06.Caption;
          7: s := x04y07.Caption;
          8: s := x04y08.Caption;
          9: s := x04y09.Caption;
        end;
      5: case y of
          1: s := x05y01.Caption;
          2: s := x05y02.Caption;
          3: s := x05y03.Caption;
          4: s := x05y04.Caption;
          5: s := x05y05.Caption;
          6: s := x05y06.Caption;
          7: s := x05y07.Caption;
          8: s := x05y08.Caption;
          9: s := x05y09.Caption;
        end;
      6: case y of
          1: s := x06y01.Caption;
          2: s := x06y02.Caption;
          3: s := x06y03.Caption;
          4: s := x06y04.Caption;
          5: s := x06y05.Caption;
          6: s := x06y06.Caption;
          7: s := x06y07.Caption;
          8: s := x06y08.Caption;
          9: s := x06y09.Caption;
        end;
      7: case y of
          1: s := x07y01.Caption;
          2: s := x07y02.Caption;
          3: s := x07y03.Caption;
          4: s := x07y04.Caption;
          5: s := x07y05.Caption;
          6: s := x07y06.Caption;
          7: s := x07y07.Caption;
          8: s := x07y08.Caption;
          9: s := x07y09.Caption;
        end;
      8: case y of
          1: s := x08y01.Caption;
          2: s := x08y02.Caption;
          3: s := x08y03.Caption;
          4: s := x08y04.Caption;
          5: s := x08y05.Caption;
          6: s := x08y06.Caption;
          7: s := x08y07.Caption;
          8: s := x08y08.Caption;
          9: s := x08y09.Caption;
        end;
      9: case y of
          1: s := x09y01.Caption;
          2: s := x09y02.Caption;
          3: s := x09y03.Caption;
          4: s := x09y04.Caption;
          5: s := x09y05.Caption;
          6: s := x09y06.Caption;
          7: s := x09y07.Caption;
          8: s := x09y08.Caption;
          9: s := x09y09.Caption;
        end;
      10: case y of
          1: s := x10y01.Caption;
          2: s := x10y02.Caption;
          3: s := x10y03.Caption;
          4: s := x10y04.Caption;
          5: s := x10y05.Caption;
          6: s := x10y06.Caption;
          7: s := x10y07.Caption;
          8: s := x10y08.Caption;
          9: s := x10y09.Caption;
        end;
      11: case y of
          1: s := x11y01.Caption;
          2: s := x11y02.Caption;
          3: s := x11y03.Caption;
          4: s := x11y04.Caption;
          5: s := x11y05.Caption;
          6: s := x11y06.Caption;
          7: s := x11y07.Caption;
          8: s := x11y08.Caption;
          9: s := x11y09.Caption;
        end;
      12: case y of
          1: s := x12y01.Caption;
          2: s := x12y02.Caption;
          3: s := x12y03.Caption;
          4: s := x12y04.Caption;
          5: s := x12y05.Caption;
          6: s := x12y06.Caption;
          7: s := x12y07.Caption;
          8: s := x12y08.Caption;
          9: s := x12y09.Caption;
        end;
      13: case y of
          1: s := x13y01.Caption;
          2: s := x13y02.Caption;
          3: s := x13y03.Caption;
          4: s := x13y04.Caption;
          5: s := x13y05.Caption;
          6: s := x13y06.Caption;
          7: s := x13y07.Caption;
          8: s := x13y08.Caption;
          9: s := x13y09.Caption;
        end;
      14: case y of
          1: s := x14y01.Caption;
          2: s := x14y02.Caption;
          3: s := x14y03.Caption;
          4: s := x14y04.Caption;
          5: s := x14y05.Caption;
          6: s := x14y06.Caption;
          7: s := x14y07.Caption;
          8: s := x14y08.Caption;
          9: s := x14y09.Caption;
        end;
      15: case y of
          1: s := x15y01.Caption;
          2: s := x15y02.Caption;
          3: s := x15y03.Caption;
          4: s := x15y04.Caption;
          5: s := x15y05.Caption;
          6: s := x15y06.Caption;
          7: s := x15y07.Caption;
          8: s := x15y08.Caption;
          9: s := x15y09.Caption;
        end;
      16: case y of
          1: s := x16y01.Caption;
          2: s := x16y02.Caption;
          3: s := x16y03.Caption;
          4: s := x16y04.Caption;
          5: s := x16y05.Caption;
          6: s := x16y06.Caption;
          7: s := x16y07.Caption;
          8: s := x16y08.Caption;
          9: s := x16y09.Caption;
        end;
    end;
  end;
  Result := s;
end;

procedure Tableau_Vide;
var
  x, y: integer;
begin
  //Effacer la couleur
  for y := 1 to CasesYmax_ do
    for x := 1 to CasesXmax_ do
      Color_to_Panel2(x, y, 0, 0);
  //Effacer les données
  for y := 1 to CasesYmax_ do
    for x := 1 to CasesXmax_ do
    begin
      //Data
      Data[x, y] := '';
      //Texte
      Str_To_panel(x, y, '');
    end;
end;

procedure Data_Chargement;
var
  Fichier: string;
  s3: S003_;
  s4: S004_;
  s5: S005_;
  s6: S006_;
  s7: S007_;
  s8: S008_;
  s9: S009_;
  n: integer;
begin
  with WdMain do
  begin
    DataTaille3L := 0;
    DataTaille4L := 0;
    DataTaille5L := 0;
    DataTaille6L := 0;
    DataTaille7L := 0;
    DataTaille8L := 0;
    DataTaille9L := 0;
    //-
    //----- 3 lettres -----
    Fichier := DirExe + '3L.dta';
    AssignFile(fFil3L, Fichier);
  {$i-}
    Reset(fFil3L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil3L, s3);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data3LMax_ then
            Data3L[n] := s3;
        end;
      until EOF(fFil3L);
   {$i-}
      CloseFile(fFil3L);
{$i+}
      //Data Taille
      DataTaille3L := n;
      Panel9.Caption := IntToStr(DataTaille3L);
      if n > 0 then
        Panel2.Color := ColVertClair_
      else
        Panel2.Color := ColOrange_;
    end
    else
    begin
      Panel2.Color := ClRed;
      Panel9.Color := ClRed;
    end;
    //-
    //----- 4 lettres -----
    Fichier := DirExe + '4L.dta';
    AssignFile(fFil4L, Fichier);
  {$i-}
    Reset(fFil4L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil4L, s4);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data4LMax_ then
            Data4L[n] := s4;
        end;
      until EOF(fFil4L);
   {$i-}
      CloseFile(fFil4L);
{$i+}
      //Data Taille
      DataTaille4L := n;
      Panel10.Caption := IntToStr(DataTaille4L);
      if n > 0 then
        Panel3.Color := ColVertClair_
      else
        Panel3.Color := ColOrange_;
    end
    else
    begin
      Panel3.Color := ClRed;
      Panel10.Color := clRed;
    end;
    //-
    //----- 5 lettres -----
    Fichier := DirExe + '5L.dta';
    AssignFile(fFil5L, Fichier);
  {$i-}
    Reset(fFil5L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil5L, s5);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data5LMax_ then
            Data5L[n] := s5;
        end;
      until EOF(fFil5L);
   {$i-}
      CloseFile(fFil5L);
{$i+}
      //Data Taille
      DataTaille5L := n;
      Panel11.Caption := IntToStr(DataTaille5L);
      if n > 0 then
        Panel4.Color := ColVertClair_
      else
        Panel4.Color := ColOrange_;
    end
    else
    begin
      Panel4.Color := ClRed;
      Panel11.Color := clRed;
    end;
    //-
    //----- 6 lettres -----
    Fichier := DirExe + '6L.dta';
    AssignFile(fFil6L, Fichier);
  {$i-}
    Reset(fFil6L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil6L, s6);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data6LMax_ then
            Data6L[n] := s6;
        end;
      until EOF(fFil6L);
   {$i-}
      CloseFile(fFil6L);
{$i+}
      //Data Taille
      DataTaille6L := n;
      Panel12.Caption := IntToStr(DataTaille6L);
      if n > 0 then
        Panel5.Color := ColVertClair_
      else
        Panel5.Color := ColOrange_;
    end
    else
    begin
      Panel5.Color := ClRed;
      Panel12.Color := clRed;
    end;
    //-
    //----- 7 lettres -----
    Fichier := DirExe + '7L.dta';
    AssignFile(fFil7L, Fichier);
  {$i-}
    Reset(fFil7L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil7L, s7);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data7LMax_ then
            Data7L[n] := s7;
        end;
      until EOF(fFil7L);
   {$i-}
      CloseFile(fFil7L);
{$i+}
      //Data Taille
      DataTaille7L := n;
      Panel13.Caption := IntToStr(DataTaille7L);
      if n > 0 then
        Panel6.Color := ColVertClair_
      else
        Panel6.Color := ColOrange_;
    end
    else
    begin
      Panel6.Color := ClRed;
      Panel13.Color := clRed;
    end;
    //-
    //----- 8 lettres -----
    Fichier := DirExe + '8L.dta';
    AssignFile(fFil8L, Fichier);
  {$i-}
    Reset(fFil8L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil8L, s8);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data8LMax_ then
            Data8L[n] := s8;
        end;
      until EOF(fFil8L);
   {$i-}
      CloseFile(fFil8L);
{$i+}
      //Data Taille
      DataTaille8L := n;
      Panel14.Caption := IntToStr(DataTaille8L);
      if n > 0 then
        Panel7.Color := ColVertClair_
      else
        Panel7.Color := ColOrange_;
    end
    else
    begin
      Panel7.Color := ClRed;
      Panel14.Color := clRed;
    end;
    //-
    //----- 9 lettres -----
    Fichier := DirExe + '9L.dta';
    AssignFile(fFil9L, Fichier);
  {$i-}
    Reset(fFil9L);
{$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
    {$i-}
        Read(fFil9L, s9);
{$i+}
        if Ioresult = 0 then
        begin
          Inc(n);
          if n <= Data9LMax_ then
            Data9L[n] := s9;
        end;
      until EOF(fFil9L);
   {$i-}
      CloseFile(fFil9L);
{$i+}
      //Data Taille
      DataTaille9L := n;
      Panel15.Caption := IntToStr(DataTaille9L);
      if n > 0 then
        Panel8.Color := ColVertClair_
      else
        Panel8.Color := ColOrange_;
    end
    else
    begin
      Panel8.Color := ClRed;
      Panel15.Color := clRed;
    end;
  end;
end;

function Alea_Mot(Sens, NbLet, Crois: integer; Masque: S016_): S016_;

  function Mot_Test(Mot: S016_): boolean;
  var
    n, Nb: integer;
  begin
    Nb := 0;
    for n := 1 to Length(Mot) do
      if Mot[n] = Masque[n] then
        Inc(Nb);
    if Nb = Crois then
      Result := True
    else
      Result := False;
  end;

var
  Mot, Mt: S016_;
  n, Tr: integer;
  Ok, Fin: boolean;
begin
  //Choix aléatoire d'un mot dans la Liste
  Mot := '';
  Tr := 0;
  Ok := False;
  Fin := False;
  repeat
    case NbLet of
      3:
      begin
        n := Random(DataTaille3L) + 1;
        Mot := Data3L[n];
      end;
      4:
      begin
        n := Random(DataTaille4L) + 1;
        Mot := Data4L[n];
      end;
      5:
      begin
        n := Random(DataTaille5L) + 1;
        Mot := Data5L[n];
      end;
      6:
      begin
        n := Random(DataTaille6L) + 1;
        Mot := Data6L[n];
      end;
      7:
      begin
        n := Random(DataTaille7L) + 1;
        Mot := Data7L[n];
      end;
      8:
      begin
        n := Random(DataTaille8L) + 1;
        Mot := Data8L[n];
      end;
      9:
      begin
        n := Random(DataTaille9L) + 1;
        Mot := Data9L[n];
      end;
    end;
    case Sens of
      1: Mt := Mot;
      2:
      begin
        Mt := '';
        for n := Length(Mot) downto 1 do
          Mt := Mt + Mot[n];
      end;
    end;
    Inc(Tr);
    Ok := Mot_Test(Mt);
    //Pas de Mot convenable
    if Tr > 300000 then
      fin := True;
    Application.ProcessMessages;
  until (Stop) or (Ok) or (Fin);
  if Fin then
    Mot := '';
  Result := Mot;
end;

procedure Empl_Vides_par_Ligne;
var
  n, p: integer;
  x, y, x2, y2: integer;
  NbLet, xd, yd: integer;
  Ok: boolean;
begin
  //Clear H et V
  for y := 1 to CasesYmax_ do
  begin
    for x := 1 to CasesXmax_ do
    begin
      DataEmplH[x, y] := 0;
      DataEmplV[x, y] := 0;
    end;
  end;
  //Clear Dhb et Dbh
  for x := 1 to EmplXmax_ do
  begin
    for y := 1 to EmplYmax_ do
    begin
      DataEmplDHB[x, y] := 0;
      DataEmplDBH[x, y] := 0;
    end;
  end;
  //-
  //----- Bilan -----
  //-
  //Bilan Horizontal
  for y := 1 to CasesYmax_ do
  begin
    p := 1;
    Ok := False;
    for x := 1 to CasesXmax_ do
    begin
      case Data[x, y] of
        '':
        begin
          Inc(DataEmplH[p, y]);
          Ok := False;
        end
        else
        begin
          if not Ok then
          begin
            Inc(p);
            Ok := True;
          end;
        end;
      end;
    end;
  end;
  //Bilan Vertical
  for x := 1 to CasesXmax_ do
  begin
    p := 1;
    Ok := False;
    for y := 1 to CasesYmax_ do
    begin
      case Data[x, y] of
        '':
        begin
          Inc(DataEmplV[x, p]);
          Ok := False;
        end
        else
        begin
          if not Ok then
          begin
            Inc(p);
            Ok := True;
          end;
        end;
      end;
    end;
  end;
  //Bilan Diagonal Haut-Bas : En haut a gauche
  for x := 1 to EmplXMax_ do
  begin
    //1 - Détermination des positions des cases
    case x of
      1:
      begin
        xd := 1;
        yd := 1;
        NbLet := 1;
      end;
      2:
      begin
        xd := 1;
        yd := 2;
        NbLet := 2;
      end;
      3:
      begin
        xd := 1;
        yd := 3;
        NbLet := 3;
      end;
      4:
      begin
        xd := 1;
        yd := 4;
        NbLet := 4;
      end;
      5:
      begin
        xd := 1;
        yd := 5;
        NbLet := 5;
      end;
      6:
      begin
        xd := 1;
        yd := 6;
        NbLet := 6;
      end;
      7:
      begin
        xd := 1;
        yd := 7;
        NbLet := 7;
      end;
      8:
      begin
        xd := 1;
        yd := 8;
        NbLet := 8;
      end;
      9:
      begin
        xd := 1;
        yd := 9;
        NbLet := 9;
      end;
      //-
      10:
      begin
        xd := 2;
        yd := 9;
        NbLet := 9;
      end;
      11:
      begin
        xd := 3;
        yd := 9;
        NbLet := 9;
      end;
      12:
      begin
        xd := 4;
        yd := 9;
        NbLet := 9;
      end;
      13:
      begin
        xd := 5;
        yd := 9;
        NbLet := 9;
      end;
      14:
      begin
        xd := 6;
        yd := 9;
        NbLet := 9;
      end;
      15:
      begin
        xd := 7;
        yd := 9;
        NbLet := 9;
      end;
      16:
      begin
        xd := 8;
        yd := 9;
        NbLet := 9;
      end;
      //-
      17:
      begin
        xd := 9;
        yd := 9;
        NbLet := 8;
      end;
      18:
      begin
        xd := 10;
        yd := 9;
        NbLet := 7;
      end;
      19:
      begin
        xd := 11;
        yd := 9;
        NbLet := 6;
      end;
      20:
      begin
        xd := 12;
        yd := 9;
        NbLet := 5;
      end;
      21:
      begin
        xd := 13;
        yd := 9;
        NbLet := 4;
      end;
      22:
      begin
        xd := 14;
        yd := 9;
        NbLet := 3;
      end;
      23:
      begin
        xd := 15;
        yd := 9;
        NbLet := 2;
      end;
      24:
      begin
        xd := 16;
        yd := 9;
        NbLet := 1;
      end;
    end;
    //-
    x2 := xd;
    y2 := yd;
    //2 - Determination des vides
    y := 1;
    for n := 1 to NbLet do
    begin
      case Data[x2, y2] of
        '':
        begin
          Inc(DataEmplDHB[x, y]);
          Ok := False;
        end
        else
        begin
          if not Ok then
          begin
            Inc(y);
            Ok := True;
          end;
        end;
      end;
      Inc(x2);
      Dec(y2);
    end;
  end;
  //Bilan Diagonal Bas-Haut : En bas a gauche
  for x := 1 to EmplXMax_ do
  begin
    //1 - Détermination des positions des cases
    case x of
      1:
      begin
        xd := 1;
        yd := 9;
        NbLet := 1;
      end;
      2:
      begin
        xd := 1;
        yd := 8;
        NbLet := 2;
      end;
      3:
      begin
        xd := 1;
        yd := 7;
        NbLet := 3;
      end;
      4:
      begin
        xd := 1;
        yd := 6;
        NbLet := 4;
      end;
      5:
      begin
        xd := 1;
        yd := 5;
        NbLet := 5;
      end;
      6:
      begin
        xd := 1;
        yd := 4;
        NbLet := 6;
      end;
      7:
      begin
        xd := 1;
        yd := 3;
        NbLet := 7;
      end;
      8:
      begin
        xd := 1;
        yd := 2;
        NbLet := 8;
      end;
      9:
      begin
        xd := 1;
        yd := 1;
        NbLet := 9;
      end;
      //-
      10:
      begin
        xd := 2;
        yd := 1;
        NbLet := 9;
      end;
      11:
      begin
        xd := 3;
        yd := 1;
        NbLet := 9;
      end;
      12:
      begin
        xd := 4;
        yd := 1;
        NbLet := 9;
      end;
      13:
      begin
        xd := 5;
        yd := 1;
        NbLet := 9;
      end;
      14:
      begin
        xd := 6;
        yd := 1;
        NbLet := 9;
      end;
      15:
      begin
        xd := 7;
        yd := 1;
        NbLet := 9;
      end;
      16:
      begin
        xd := 8;
        yd := 1;
        NbLet := 9;
      end;
      //-
      17:
      begin
        xd := 9;
        yd := 1;
        NbLet := 8;
      end;
      18:
      begin
        xd := 10;
        yd := 1;
        NbLet := 7;
      end;
      19:
      begin
        xd := 11;
        yd := 1;
        NbLet := 6;
      end;
      20:
      begin
        xd := 12;
        yd := 1;
        NbLet := 5;
      end;
      21:
      begin
        xd := 13;
        yd := 1;
        NbLet := 4;
      end;
      22:
      begin
        xd := 14;
        yd := 1;
        NbLet := 3;
      end;
      23:
      begin
        xd := 15;
        yd := 1;
        NbLet := 2;
      end;
      24:
      begin
        xd := 16;
        yd := 1;
        NbLet := 1;
      end;
    end;
    //-
    x2 := xd;
    y2 := yd;
    //2 - Determination des vides
    y := 1;
    for n := 1 to NbLet do
    begin
      case Data[x2, y2] of
        '':
        begin
          Inc(DataEmplDBH[x, y]);
          Ok := False;
        end
        else
        begin
          if not Ok then
          begin
            Inc(y);
            Ok := True;
          end;
        end;
      end;
      Inc(x2);
      Inc(y2);
    end;
  end;
end;

function Empl_Reste_Bilan: integer;
var
  Dh, Dv, DHb, DBh: integer;
  x, y, Reste: integer;
begin
  Reste := 0;
  //Horizontal
  Dh := 0;
  for y := 1 to CasesYmax_ do
    for x := 1 to CasesXmax_ do
      if DataEmplH[x, y] > Dh then
        Dh := DataEmplH[x, y];
  //Vertical
  Dv := 0;
  for x := 1 to CasesXmax_ do
    for y := 1 to CasesYmax_ do
      if DataEmplV[x, y] > Dv then
        Dv := DataEmplH[x, y];
  //Diagonal HB
  DHb := 0;
  for x := 1 to EmplxMax_ do
    for y := 1 to EmplyMax_ do
      if DataEmplDHB[x, y] > DHb then
        DHb := DataEmplDHB[x, y];
  //Diagonal BH
  DBh := 0;
  for x := 1 to EmplxMax_ do
    for y := 1 to EmplyMax_ do
      if DataEmplDBH[x, y] > DBh then
        DBh := DataEmplDBH[x, y];
  //Reste maximum
  Reste := Dh;
  if Dv > Reste then
    Reste := Dv;
  if DHb > Reste then
    Reste := DHb;
  if DBh > Reste then
    Reste := DBh;
  //-
  Result := Reste;
end;

procedure Box_Affiche;
var
  n: integer;
begin
  with WdMain do
  begin
    ListBox1.Items.Clear;
    for n := 1 to ListeMotsNbMax do
    begin
      with ListeMots[n] do
      begin
        if LmOk = 0 then
        begin
          ListBox1.Items.Add(LmMot1);
        end;
      end;
    end;
    //Début de liste
    if ListBox1.Count > 0 then
      ListBox1.ItemIndex := 0;
    Label18.Caption := 'Mots restants (' + IntToStr(ListBox1.Items.Count) + ')';
  end;
end;

procedure Genere;
const
  EmplListeMax_ = 144;
  CrFin_ = 1;
var
  EmplVidesListe: array[1..EmplListeMax_] of Tpoint;
  EmplVidesListeCount: integer;

  procedure Liste_Init;
  var
    n: integer;
  begin
    //Liste Mots
    for n := 1 to ListeMotsMax_ do
      with ListeMots[n] do
      begin
        LmMot1 := '';
        LmMot2 := '';
        LmOrient := 0;
        LmSens := 0;
        LmNbLet := 0;
        LmAffXd := 0;
        LmAffYd := 0;
        LmAffXf := 0;
        LmAffYf := 0;
        LmClicXd := 0;
        LmClicYd := 0;
        LmClicXf := 0;
        LmClicYf := 0;
        LmOk := 0;
      end;
    ListeMotsNb := 0;
    ListeMotsNbMax := 0;
  end;

  function Emplacements_Vides_par_Case: integer;
  var
    n, x, y: integer;
  begin
    //Clear
    for n := 1 to EmplListeMax_ do
    begin
      EmplVidesListe[n].x := 0;
      EmplVidesListe[n].y := 0;
    end;
    n := 0;
    for y := 1 to CasesYmax_ do
      for x := 1 to CasesXmax_ do
        if Data[x, y] = '' then
        begin
          Inc(n);
          EmplVidesListe[n].x := x;
          EmplVidesListe[n].y := y;
        end;
    Result := n;
  end;

  function Emplacement_Alea2: Tpoint;
  var
    p: Tpoint;
  begin
    repeat
      p.x := Alea(CasesXMax_);
      p.y := Alea(CasesYMax_);
    until (Data[p.x, p.y] = '');
    Result := p;
  end;

  function Croisements_xy(Orient, xd, yd, xf, yf: integer): integer;
  var
    Crois: integer;
    x, y: integer;
  begin
    Crois := 0;
    case Orient of
      //Horizontal
      1:
      begin
        for x := xd to xf do
          if Panel_to_Str(x, yd) <> '' then
            Inc(Crois);
      end;
      //Vertical
      2:
      begin
        for y := yd to yf do
          if Panel_to_Str(xd, y) <> '' then
            Inc(Crois);
      end;
      //Diagonal HG
      3:
      begin
        x := xd;
        y := yd;
        repeat
          if Panel_to_Str(x, y) <> '' then
            Inc(Crois);
          Inc(x);
          Inc(y);
        until x > xf;
      end;
      //Diagonal HD
      4:
      begin
        x := xd;
        y := yd;
        repeat
          if Panel_to_Str(x, y) <> '' then
            Inc(Crois);
          Dec(x);
          Inc(y);
        until x < 1;
      end;
    end;
    Result := Crois;
  end;

  function Croisements_Masque(Orient, xd, yd, xf, yf: integer): S016_;
  var
    Masque: S016_;
    s: S016_;
    x, y: integer;
  begin
    Masque := '';
    case Orient of
      //Horizontal
      1:
      begin
        for x := xd to xf do
        begin
          s := Panel_to_Str(x, yd);
          if s = '' then
            s := '.';
          Masque := Masque + s;
        end;
      end;
      //Vertical
      2:
      begin
        for y := yd to yf do
        begin
          s := Panel_to_Str(xd, y);
          if s = '' then
            s := '.';
          Masque := Masque + s;
        end;
      end;
      //Diagonal HG
      3:
      begin
        x := xd;
        y := yd;
        repeat
          s := Panel_to_Str(x, y);
          if s = '' then
            s := '.';
          Masque := Masque + s;
          Inc(x);
          Inc(y);
        until x > xf;
      end;
      //Diagonal HD
      4:
      begin
        x := xd;
        y := yd;
        repeat
          s := Panel_to_Str(x, y);
          if s = '' then
            s := '.';
          Masque := Masque + s;
          Dec(x);
          Inc(y);
        until x < 1;
      end;
    end;
    Result := Masque;
  end;

  procedure Affiche_Tableau(Emplacement: integer);
  var
    Col: TColor;
    n, x, y: integer;
  begin
    with WdMain do
    begin
      with ListeMots[Emplacement] do
      begin
        //Validation des cases
        case LmOrient of
          1: Col := ColRouge_;
          2: Col := ColBleu_;
          3: Col := ColVertClair_;
          4: Col := ClYellow;
          else
            Col := ColVert_;
        end;
        //-
        case LmOrient of
          //Horizontal
          1:
          begin
            for n := 1 to LmNbLet do
            begin
              x := LmAffXd + n - 1;
              y := LmAffYd;
              case LmSens of
                1:
                begin
                  Data[x, y] := LmMot1[n];
                  Str_to_Panel(x, y, LmMot1[n]);
                end;
                2:
                begin
                  Data[x, y] := LmMot2[n];
                  Str_to_Panel(x, y, LmMot2[n]);
                end;
              end;
            end;
          end;
          //Vertical
          2:
          begin
            for n := 1 to LmNbLet do
            begin
              x := LmAffXd;
              y := LmAffYd + n - 1;
              case LmSens of
                1:
                begin
                  Data[x, y] := LmMot1[n];
                  Str_to_Panel(x, y, LmMot1[n]);
                end;
                2:
                begin
                  Data[x, y] := LmMot2[n];
                  Str_to_Panel(x, y, LmMot2[n]);
                end;
              end;
            end;
          end;
          //Diagonal Haut-Gauche
          3:
          begin
            for n := 1 to LmNbLet do
            begin
              x := LmAffXd + n - 1;
              y := LmAffYd + n - 1;
              case LmSens of
                1:
                begin
                  Data[x, y] := LmMot1[n];
                  Str_to_Panel(x, y, LmMot1[n]);
                end;
                2:
                begin
                  Data[x, y] := LmMot2[n];
                  Str_to_Panel(x, y, LmMot2[n]);
                end;
              end;
            end;
          end;
          //Diagonal Haut-Droite
          4:
          begin
            for n := 1 to LmNbLet do
            begin
              x := LmAffXd - n + 1;
              y := LmAffYd + n - 1;
              case LmSens of
                1:
                begin
                  Data[x, y] := LmMot1[n];
                  Str_to_Panel(x, y, LmMot1[n]);
                end;
                2:
                begin
                  Data[x, y] := LmMot2[n];
                  Str_to_Panel(x, y, LmMot2[n]);
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;

  procedure Complement;
  var
    x, y: integer;
    c: byte;
  begin
    for y := 1 to CasesYmax_ do
    begin
      for x := 1 to CasesXmax_ do
      begin
        if Panel_to_Str(x, y) = '' then
        begin
          repeat
            c := Random(90);
          until c in [65..90];
          Str_to_Panel(x, y, Chr(c));
        end;
      end;
    end;
  end;

  procedure Alea_NbLet(Emplacement: integer; var NbLet: integer);
  begin
    case Emplacement of
      0..7: NbLet := AleaDB(7, 9);
      8..11: NbLet := AleaDB(5, 6);
      else
      begin
        NbLet := AleaDB(3, 9);
      end;
    end;
  end;

  procedure Alea_Orient(Emplacement: integer; var Orient, s0, s1, s2: integer);
  begin
    case Emplacement of
      0:
      begin
        Orient := Random(4) + 1;
        s0 := Orient;
      end;
      1:
      begin
        repeat
          Orient := Random(4) + 1;
        until Orient <> s0;
        s1 := Orient;
      end;
      2:
      begin
        repeat
          Orient := Random(4) + 1;
        until (Orient <> s0) and (Orient <> s1);
        s2 := Orient;
      end;
      3:
      begin
        repeat
          Orient := Random(4) + 1;
        until (Orient <> s0) and (Orient <> s1) and (Orient <> s2);
      end;
      else
      begin
        repeat
          Orient := Alea(4);
        until Orient <> ListeMots[ListeMotsNb - 1].LmOrient;
      end;
    end;
  end;

  function Alea_Sens(Emplacement: integer): integer;
  var
    v: integer;
  begin
    v := 1;
    case Emplacement of
      0: v := Alea(2);
      else
      begin
        repeat
          v := Random(2) + 1;
        until v <> ListeMots[Emplacement - 1].LmSens;
      end;
    end;
    Result := v;
  end;

  procedure xf_yf(Orient, NbLet, x, y: integer; var xf, yf: integer);
  begin
    case Orient of
      1:
      begin
        xf := x + NbLet - 1;
        yf := y;
      end;
      2:
      begin
        xf := x;
        yf := y + NbLet - 1;
      end;
      //Diagonal Haut-Gauche
      3:
      begin
        xf := x + NbLet - 1;
        yf := y + NbLet - 1;
      end;
      //Diagonal Haut-Droit
      4:
      begin
        xf := x - NbLet + 1;
        yf := y + NbLet - 1;
      end;
    end;
  end;

  function Fin_de_Mot_Test(Orient, xf, yf: integer): boolean;
  var
    Ok: boolean;
  begin
    Ok := False;
    case Orient of
      1: if xf <= CasesXMax_ then
          Ok := True;
      2: if yf <= CasesYMax_ then
          Ok := True;
      3: if (xf <= CasesXMax_) and (yf <= CasesYMax_) then
          Ok := True;
      4: if (xf >= 1) and (yf <= CasesYMax_) then
          Ok := True;
    end;
    Result := Ok;
  end;

var
  Mot: S016_;
  Masque: S016_;
  NbLet, Orient: integer;
  n, Sens: integer;
  xd, yd: integer;
  xf, yf: integer;
  s0, s1, s2: integer;
  Crois, Reste: integer;
  Ok: boolean;
begin
  //Génère
  with WdMain do
  begin
    ListBox2.Color := ColGris_;
    ListBox1.Color := ColGris_;
    ListBox1.Sorted := False;
    SpeedButton3.Enabled := False;
    SpeedButton2.Enabled := True;
    //Tableau vide
    Tableau_Vide;
    //Liste Init.
    Liste_Init;
    //-
    //Selection Clear
    SelectMem.XY1.x := 0;
    SelectMem.XY1.y := 0;
    SelectMem.XY2.x := 0;
    SelectMem.XY2.y := 0;
    SelectMem.Col1 := 0;
    SelectMem.Col2 := 0;
    //-
    ListBox2.Items.Clear;
    ListBox2.Color := ColBox_;
    ListBox1.Items.Clear;
    Panel16.Color := ColJaune_;
    Tableau_Vide;
    //-
    s0 := 0;
    s1 := 0;
    s2 := 0;
    Stop := False;
    repeat
      //Bilan des vides par ligne
      Empl_Vides_par_Ligne;
      //Reste de NbLet dans le tableau
      Reste := Empl_Reste_Bilan;
      if Reste > 2 then
      begin
        //Bilan des vides par case (16 x 9)
        EmplVidesListeCount := Emplacements_Vides_par_Case;
        //----- ORIENT -----
        //Sens de l'orientation
        //1:H 2:V 3:D Haut-Bas 4:D Bas-Haut
        Orient := 1;
        Alea_Orient(ListeMotsNb, Orient, s0, s1, s2);
        //-
        //----- NBLET -----
        //Nombre de lettres -----
        NbLet := 3;
        Alea_NbLet(ListeMotsNb, NbLet);
        //-
        //----- X,Y -----
        //Position aléatoire dans les vides
        //et Test
        Ok := False;
        n := Alea(EmplVidesListeCount);
        xd := EmplVidesListe[n].x;
        yd := EmplVidesListe[n].y;
        //Fin de Mot
        xf := 0;
        yf := 0;
        xf_yf(Orient, NbLet, xd, yd, xf, yf);
        Ok := Fin_de_Mot_Test(Orient, xf, yf);
        if Ok then
        begin
          //----- VALIDATION du MOT -----
          //Validation de l'orientation pour le départ
          Crois := 0;
          Crois := Croisements_xy(Orient, xd, yd, xf, yf);
          Masque := Croisements_Masque(Orient, xd, yd, xf, yf);
          //Gestion jusqu'a CrFin_ croisements
          if Crois in [0..CrFin_] then
          begin
            //----- SENS -----
            //Sens du Mot : endroit ou envers
            Sens := Alea_Sens(ListeMotsNb);
            //Mot
            Mot := Alea_Mot(Sens, NbLet, Crois, Masque);
            if Mot <> '' then
            begin
              //----- VALIDATION du MOT -----
              Inc(ListeMotsNb);
              if ListeMotsNb <= ListeMotsMax_ then
              begin
                with ListeMots[ListeMotsNb] do
                begin
                  //Orientation
                  LmOrient := Orient;
                  //Sens
                  LmSens := Sens;
                  //NbLet
                  LmNbLet := NbLet;
                  //Mot
                  LmMot1 := Mot;
                  LmMot2 := '';
                  for n := Length(Mot) downto 1 do
                    LmMot2 := LmMot2 + Mot[n];
                  //Coordonnées Affichage
                  LmAffXd := xd;
                  LmAffYd := yd;
                  LmAffXf := xf;
                  LmAffYf := yf;
                  //Coordonnées du Clic de la souris
                  case Sens of
                    1:
                    begin
                      LmClicXd := LmAffXd;
                      LmClicYd := LmAffYd;
                      LmClicXf := LmAffXf;
                      LmClicYf := LmAffYf;
                    end;
                    2:
                    begin
                      LmClicXd := LmAffXf;
                      LmClicYd := LmAffYf;
                      LmClicXf := LmAffXd;
                      LmClicYf := LmAffYd;
                    end;
                  end;
                  //Mot trouvé
                  LmOk := 0;
                end;
                //Affichage dans la Liste
                WdMain.ListBox2.Items.Add(ListeMots[ListeMotsNb].LmMot1);
                //Affichage tableau
                Affiche_Tableau(ListeMotsNb);
                panel16.Caption := '0/' + IntToStr(ListeMotsNb);
              end
              else
              begin
                ShowMessage('Ajout dans la Liste impossible');
                Stop := True;
              end;
            end;
          end;
        end;
      end;
      Application.ProcessMessages;
    until (Stop) or (Reste < 3) or (EmplVidesListeCount <= 0) or (ListeMotsNb >= 28);
    //Complément pour les cases vides
    Complement;
    //-
    ListeMotsNbMax := ListeMotsNb;
    //-
    Label17.Caption := 'Liste complète (' + IntToStr(ListBox2.Items.Count) + ')';
    //-
    Box_Affiche;
    ListBox1.Sorted := True;
    if ListBox1.Items.Count > 0 then
      ListBox1.ItemIndex := 0;
    //-
    Panel16.Caption := '0/' + IntToStr(ListeMotsNbMax);
    Panel16.Color := ColVertClair_;
    SpeedButton2.Enabled := False;
    SpeedButton3.Enabled := True;
    //Début de liste
    if ListBox2.Items.Count > 0 then
      ListBox2.ItemIndex := 0;
    //Solution Enabled
    SpeedButton4.Enabled := True;
    //-
    ListBox2.Color := ColBox_;
    ListBox1.Color := ColBox_;
    PnSel1.Color := ColBleu2_;
    PnSel2.Color := ColBleu2_;
    //-
    ShowMessage('            Clic sur le début et la fin du mot recherché.');
    //Départ du chronometre
    HeureDeDepart := now;
    Timer1.Enabled := True;
  end;
end;

procedure Solution;
var
  s, t: string;
  n, Ct: integer;
begin
  with WdMain do
  begin
    Ct := ListBox2.Items.Count;
    if Ct > 0 then
    begin
      for n := 1 to Ct do
      begin
        with ListeMots[n] do
        begin
          s := IntToStr(LmClicXd);
          if Length(s) < 2 then
            s := '0' + s;
          t := IntToStr(LmClicYd);
          if Length(t) < 2 then
            t := '0' + t;
          s := '[' + s + '/' + t;
          case LmOrient of
            1: s := s + ' H] ';
            2: s := s + ' V] ';
            3: s := s + ' D] ';
            4: s := s + ' D] ';
          end;
          ListBox2.Items[n - 1] := s + ListBox2.Items[n - 1];
          if ListBox2.Items.Count > 0 then
            ListBox2.ItemIndex := 0;
        end;
      end;
    end;
    SpeedButton4.Enabled := False;
  end;
end;

procedure Init;
begin
  with WdMain do
  begin
    //Général
    ListBox2.Items.Clear;
    ListBox2.Color := ColGris_;
    ListBox1.Items.Clear;
    //Selection
    Sel1.x := 0;
    Sel1.y := 0;
    Sel2.x := 0;
    Sel2.y := 0;
  end;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  Stop := True;
end;

procedure TWdMain.SpeedButton3Click(Sender: TObject);
begin
  Genere;
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  Solution;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
var
  HeureCourante: TDateTime;
  Interval: TDateTime;
begin
  HeureCourante := Now;
  Interval := HeureCourante - HeureDeDepart;
  Panel17.Caption := TimeToStr(Interval);
end;

procedure Selection(x, y: integer);

  function Liste_Nb: integer;
  var
    n, Nb: integer;
  begin
    Nb := 0;
    for n := 1 to ListeMotsNbMax do
    begin
      with ListeMots[n] do
      begin
        if LmOk = 1 then
          Inc(Nb);
      end;
    end;
    Result := Nb;
  end;

var
  Interval: TDateTime;
  s: string;
  n, Nb: integer;
  x1, y1, x2, y2: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    if Panel_to_Color(x, y) = ColVert_ then
    begin
      //Case en Jaune
      Color_to_Panel2(x, y, 0, 0);
      if (Sel1.x = x) and (Sel1.y = y) then
        PnSel1.Color := ColBleu2_;
      if (Sel2.x = x) and (Sel2.y = y) then
        PnSel2.Color := ColBleu2_;
    end
    else
    begin
      //1er point
      if (SelectMem.XY1.x = 0) and (SelectMem.XY1.y = 0) then
      begin
        SelectMem.XY1.x := x;
        SelectMem.XY1.y := y;
        SelectMem.Col1 := Panel_to_Color(x, y);
        //Vert
        Color_to_Panel2(x, y, 0, 1);
        PnSel1.Color := ColVert_;
        Sel1.x := x;
        Sel1.y := y;
      end
      else
      begin
        //2eme point
        if (SelectMem.XY2.x = 0) and (SelectMem.XY2.y = 0) then
        begin
          SelectMem.XY2.x := x;
          SelectMem.XY2.y := y;
          SelectMem.Col2 := Panel_to_Color(x, y);
          //Vert
          Color_to_Panel2(x, y, 0, 1);
          PnSel2.Color := ColVert_;
          Sel2.x := x;
          Sel2.y := y;
          //-
          //----- Recherche du Mot -----
          x1 := SelectMem.XY1.x;
          y1 := SelectMem.XY1.y;
          x2 := SelectMem.XY2.x;
          y2 := SelectMem.XY2.y;
          Ok := False;
          n := 1;
          repeat
            with ListeMots[n] do
            begin
              if ((LmClicXd = x1) and (LmClicYd = y1)) and
                ((LmClicXf = x2) and (LmClicYf = y2)) then
              begin
                //Mot trouvé
                LmOk := 1;
                s := ListBox2.Items[n - 1];
                if s[1] = '[' then
                begin
                  Insert('<', s, 11);
                  s := s + '>';
                end
                else
                begin
                  s := '<' + s + '>';
                end;
                ListBox2.Items[n - 1] := s;
                Box_Affiche;
                //Affiche couleur
                ColorAll_to_Panel(n);
                Ok := True;
              end;
            end;
            Inc(n);
          until (Ok) or (n > ListeMotsNb);
          Application.ProcessMessages;
          //-
          Nb := Liste_Nb;
          Panel16.Caption := IntToStr(Nb) + '/' + IntToStr(ListeMotsNbMax);
          if not Ok then
          begin
            Application.ProcessMessages;
            Sleep(400);
            Color_to_Panel(x1, y1, SelectMem.Col1);
            Color_to_Panel(x2, y2, SelectMem.Col2);
          end;
          if (Nb > 0 and ListeMotsNbMax) and (Nb >= ListeMotsNbMax) then
          begin
            //Chrono
            HeureArrivee := Now;
            Timer1.Enabled := False;
            Interval := HeureArrivee - HeureDeDepart;
            Panel17.Caption := TimeToStr(Interval);
            //-
            ListBox2.Color := ColVertClair_;
            ShowMessage('      Félicitation, mots mêlés terminé !' +
              #9#10 + #9#10 + '      Chrono : ' + TimeToStr(Interval));
          end;
          //Clear
          SelectMem.XY1.x := 0;
          SelectMem.XY1.y := 0;
          SelectMem.XY2.x := 0;
          SelectMem.XY2.y := 0;
          SelectMem.Col1 := 0;
          SelectMem.Col2 := 0;
          //Selection
          Sel1.x := 0;
          Sel1.y := 0;
          PnSel1.Color := ColBleu2_;
          Sel2.x := 0;
          Sel2.y := 0;
          PnSel2.Color := ColBleu2_;
        end;
      end;
    end;
  end;
end;

procedure TWdMain.x01y01Click(Sender: TObject);
begin
  Selection(1, 1);
end;

procedure TWdMain.x01y02Click(Sender: TObject);
begin
  Selection(1, 2);
end;

procedure TWdMain.x01y03Click(Sender: TObject);
begin
  Selection(1, 3);
end;

procedure TWdMain.x01y04Click(Sender: TObject);
begin
  Selection(1, 4);
end;

procedure TWdMain.x01y05Click(Sender: TObject);
begin
  Selection(1, 5);
end;

procedure TWdMain.x01y06Click(Sender: TObject);
begin
  Selection(1, 6);
end;

procedure TWdMain.x01y07Click(Sender: TObject);
begin
  Selection(1, 7);
end;

procedure TWdMain.x01y08Click(Sender: TObject);
begin
  Selection(1, 8);
end;

procedure TWdMain.x01y09Click(Sender: TObject);
begin
  Selection(1, 9);
end;

procedure TWdMain.x02y01Click(Sender: TObject);
begin
  Selection(2, 1);
end;

procedure TWdMain.x02y02Click(Sender: TObject);
begin
  Selection(2, 2);
end;

procedure TWdMain.x02y03Click(Sender: TObject);
begin
  Selection(2, 3);
end;

procedure TWdMain.x02y04Click(Sender: TObject);
begin
  Selection(2, 4);
end;

procedure TWdMain.x02y05Click(Sender: TObject);
begin
  Selection(2, 5);
end;

procedure TWdMain.x02y06Click(Sender: TObject);
begin
  Selection(2, 6);
end;

procedure TWdMain.x02y07Click(Sender: TObject);
begin
  Selection(2, 7);
end;

procedure TWdMain.x02y08Click(Sender: TObject);
begin
  Selection(2, 8);
end;

procedure TWdMain.x02y09Click(Sender: TObject);
begin
  Selection(2, 9);
end;

procedure TWdMain.x03y01Click(Sender: TObject);
begin
  Selection(3, 1);
end;

procedure TWdMain.x03y02Click(Sender: TObject);
begin
  Selection(3, 2);
end;

procedure TWdMain.x03y03Click(Sender: TObject);
begin
  Selection(3, 3);
end;

procedure TWdMain.x03y04Click(Sender: TObject);
begin
  Selection(3, 4);
end;

procedure TWdMain.x03y05Click(Sender: TObject);
begin
  Selection(3, 5);
end;

procedure TWdMain.x03y06Click(Sender: TObject);
begin
  Selection(3, 6);
end;

procedure TWdMain.x03y07Click(Sender: TObject);
begin
  Selection(3, 7);
end;

procedure TWdMain.x03y08Click(Sender: TObject);
begin
  Selection(3, 8);
end;

procedure TWdMain.x03y09Click(Sender: TObject);
begin
  Selection(3, 9);
end;

procedure TWdMain.x04y01Click(Sender: TObject);
begin
  Selection(4, 1);
end;

procedure TWdMain.x04y02Click(Sender: TObject);
begin
  Selection(4, 2);
end;

procedure TWdMain.x04y03Click(Sender: TObject);
begin
  Selection(4, 3);
end;

procedure TWdMain.x04y04Click(Sender: TObject);
begin
  Selection(4, 4);
end;

procedure TWdMain.x04y05Click(Sender: TObject);
begin
  Selection(4, 5);
end;

procedure TWdMain.x04y06Click(Sender: TObject);
begin
  Selection(4, 6);
end;

procedure TWdMain.x04y07Click(Sender: TObject);
begin
  Selection(4, 7);
end;

procedure TWdMain.x04y08Click(Sender: TObject);
begin
  Selection(4, 8);
end;

procedure TWdMain.x04y09Click(Sender: TObject);
begin
  Selection(4, 9);
end;

procedure TWdMain.x05y01Click(Sender: TObject);
begin
  Selection(5, 1);
end;

procedure TWdMain.x05y02Click(Sender: TObject);
begin
  Selection(5, 2);
end;

procedure TWdMain.x05y03Click(Sender: TObject);
begin
  Selection(5, 3);
end;

procedure TWdMain.x05y04Click(Sender: TObject);
begin
  Selection(5, 4);
end;

procedure TWdMain.x05y05Click(Sender: TObject);
begin
  Selection(5, 5);
end;

procedure TWdMain.x05y06Click(Sender: TObject);
begin
  Selection(5, 6);
end;

procedure TWdMain.x05y07Click(Sender: TObject);
begin
  Selection(5, 7);
end;

procedure TWdMain.x05y08Click(Sender: TObject);
begin
  Selection(5, 8);
end;

procedure TWdMain.x05y09Click(Sender: TObject);
begin
  Selection(5, 9);
end;

procedure TWdMain.x06y01Click(Sender: TObject);
begin
  Selection(6, 1);
end;

procedure TWdMain.x06y02Click(Sender: TObject);
begin
  Selection(6, 2);
end;

procedure TWdMain.x06y03Click(Sender: TObject);
begin
  Selection(6, 3);
end;

procedure TWdMain.x06y04Click(Sender: TObject);
begin
  Selection(6, 4);
end;

procedure TWdMain.x06y05Click(Sender: TObject);
begin
  Selection(6, 5);
end;

procedure TWdMain.x06y06Click(Sender: TObject);
begin
  Selection(6, 6);
end;

procedure TWdMain.x06y07Click(Sender: TObject);
begin
  Selection(6, 7);
end;

procedure TWdMain.x06y08Click(Sender: TObject);
begin
  Selection(6, 8);
end;

procedure TWdMain.x06y09Click(Sender: TObject);
begin
  Selection(6, 9);
end;

procedure TWdMain.x07y01Click(Sender: TObject);
begin
  Selection(7, 1);
end;

procedure TWdMain.x07y02Click(Sender: TObject);
begin
  Selection(7, 2);
end;

procedure TWdMain.x07y03Click(Sender: TObject);
begin
  Selection(7, 3);
end;

procedure TWdMain.x07y04Click(Sender: TObject);
begin
  Selection(7, 4);
end;

procedure TWdMain.x07y05Click(Sender: TObject);
begin
  Selection(7, 5);
end;

procedure TWdMain.x07y06Click(Sender: TObject);
begin
  Selection(7, 6);
end;

procedure TWdMain.x07y07Click(Sender: TObject);
begin
  Selection(7, 7);
end;

procedure TWdMain.x07y08Click(Sender: TObject);
begin
  Selection(7, 8);
end;

procedure TWdMain.x07y09Click(Sender: TObject);
begin
  Selection(7, 9);
end;

procedure TWdMain.x08y01Click(Sender: TObject);
begin
  Selection(8, 1);
end;

procedure TWdMain.x08y02Click(Sender: TObject);
begin
  Selection(8, 2);
end;

procedure TWdMain.x08y03Click(Sender: TObject);
begin
  Selection(8, 3);
end;

procedure TWdMain.x08y04Click(Sender: TObject);
begin
  Selection(8, 4);
end;

procedure TWdMain.x08y05Click(Sender: TObject);
begin
  Selection(8, 5);
end;

procedure TWdMain.x08y06Click(Sender: TObject);
begin
  Selection(8, 6);
end;

procedure TWdMain.x08y07Click(Sender: TObject);
begin
  Selection(8, 7);
end;

procedure TWdMain.x08y08Click(Sender: TObject);
begin
  Selection(8, 8);
end;

procedure TWdMain.x08y09Click(Sender: TObject);
begin
  Selection(8, 9);
end;

procedure TWdMain.x09y01Click(Sender: TObject);
begin
  Selection(9, 1);
end;

procedure TWdMain.x09y02Click(Sender: TObject);
begin
  Selection(9, 2);
end;

procedure TWdMain.x09y03Click(Sender: TObject);
begin
  Selection(9, 3);
end;

procedure TWdMain.x09y04Click(Sender: TObject);
begin
  Selection(9, 4);
end;

procedure TWdMain.x09y05Click(Sender: TObject);
begin
  Selection(9, 5);
end;

procedure TWdMain.x09y06Click(Sender: TObject);
begin
  Selection(9, 6);
end;

procedure TWdMain.x09y07Click(Sender: TObject);
begin
  Selection(9, 7);
end;

procedure TWdMain.x09y08Click(Sender: TObject);
begin
  Selection(9, 8);
end;

procedure TWdMain.x09y09Click(Sender: TObject);
begin
  Selection(9, 9);
end;

procedure TWdMain.x10y01Click(Sender: TObject);
begin
  Selection(10, 1);
end;

procedure TWdMain.x10y02Click(Sender: TObject);
begin
  Selection(10, 2);
end;

procedure TWdMain.x10y03Click(Sender: TObject);
begin
  Selection(10, 3);
end;

procedure TWdMain.x10y04Click(Sender: TObject);
begin
  Selection(10, 4);
end;

procedure TWdMain.x10y05Click(Sender: TObject);
begin
  Selection(10, 5);
end;

procedure TWdMain.x10y06Click(Sender: TObject);
begin
  Selection(10, 6);
end;

procedure TWdMain.x10y07Click(Sender: TObject);
begin
  Selection(10, 7);
end;

procedure TWdMain.x10y08Click(Sender: TObject);
begin
  Selection(10, 8);
end;

procedure TWdMain.x10y09Click(Sender: TObject);
begin
  Selection(10, 9);
end;

procedure TWdMain.x11y01Click(Sender: TObject);
begin
  Selection(11, 1);
end;

procedure TWdMain.x11y02Click(Sender: TObject);
begin
  Selection(11, 2);
end;

procedure TWdMain.x11y03Click(Sender: TObject);
begin
  Selection(11, 3);
end;

procedure TWdMain.x11y04Click(Sender: TObject);
begin
  Selection(11, 4);
end;

procedure TWdMain.x11y05Click(Sender: TObject);
begin
  Selection(11, 5);
end;

procedure TWdMain.x11y06Click(Sender: TObject);
begin
  Selection(11, 6);
end;

procedure TWdMain.x11y07Click(Sender: TObject);
begin
  Selection(11, 7);
end;

procedure TWdMain.x11y08Click(Sender: TObject);
begin
  Selection(11, 8);
end;

procedure TWdMain.x11y09Click(Sender: TObject);
begin
  Selection(11, 9);
end;

procedure TWdMain.x12y01Click(Sender: TObject);
begin
  Selection(12, 1);
end;

procedure TWdMain.x12y02Click(Sender: TObject);
begin
  Selection(12, 2);
end;

procedure TWdMain.x12y03Click(Sender: TObject);
begin
  Selection(12, 3);
end;

procedure TWdMain.x12y04Click(Sender: TObject);
begin
  Selection(12, 4);
end;

procedure TWdMain.x12y05Click(Sender: TObject);
begin
  Selection(12, 5);
end;

procedure TWdMain.x12y06Click(Sender: TObject);
begin
  Selection(12, 6);
end;

procedure TWdMain.x12y07Click(Sender: TObject);
begin
  Selection(12, 7);
end;

procedure TWdMain.x12y08Click(Sender: TObject);
begin
  Selection(12, 8);
end;

procedure TWdMain.x12y09Click(Sender: TObject);
begin
  Selection(12, 9);
end;

procedure TWdMain.x13y01Click(Sender: TObject);
begin
  Selection(13, 1);
end;

procedure TWdMain.x13y02Click(Sender: TObject);
begin
  Selection(13, 2);
end;

procedure TWdMain.x13y03Click(Sender: TObject);
begin
  Selection(13, 3);
end;

procedure TWdMain.x13y04Click(Sender: TObject);
begin
  Selection(13, 4);
end;

procedure TWdMain.x13y05Click(Sender: TObject);
begin
  Selection(13, 5);
end;

procedure TWdMain.x13y06Click(Sender: TObject);
begin
  Selection(13, 6);
end;

procedure TWdMain.x13y07Click(Sender: TObject);
begin
  Selection(13, 7);
end;

procedure TWdMain.x13y08Click(Sender: TObject);
begin
  Selection(13, 8);
end;

procedure TWdMain.x13y09Click(Sender: TObject);
begin
  Selection(13, 9);
end;

procedure TWdMain.x14y01Click(Sender: TObject);
begin
  Selection(14, 1);
end;

procedure TWdMain.x14y02Click(Sender: TObject);
begin
  Selection(14, 2);
end;

procedure TWdMain.x14y03Click(Sender: TObject);
begin
  Selection(14, 3);
end;

procedure TWdMain.x14y04Click(Sender: TObject);
begin
  Selection(14, 4);
end;

procedure TWdMain.x14y05Click(Sender: TObject);
begin
  Selection(14, 5);
end;

procedure TWdMain.x14y06Click(Sender: TObject);
begin
  Selection(14, 6);
end;

procedure TWdMain.x14y07Click(Sender: TObject);
begin
  Selection(14, 7);
end;

procedure TWdMain.x14y08Click(Sender: TObject);
begin
  Selection(14, 8);
end;

procedure TWdMain.x14y09Click(Sender: TObject);
begin
  Selection(14, 9);
end;

procedure TWdMain.x15y01Click(Sender: TObject);
begin
  Selection(15, 1);
end;

procedure TWdMain.x15y02Click(Sender: TObject);
begin
  Selection(15, 2);
end;

procedure TWdMain.x15y03Click(Sender: TObject);
begin
  Selection(15, 3);
end;

procedure TWdMain.x15y04Click(Sender: TObject);
begin
  Selection(15, 4);
end;

procedure TWdMain.x15y05Click(Sender: TObject);
begin
  Selection(15, 5);
end;

procedure TWdMain.x15y06Click(Sender: TObject);
begin
  Selection(15, 6);
end;

procedure TWdMain.x15y07Click(Sender: TObject);
begin
  Selection(15, 7);
end;

procedure TWdMain.x15y08Click(Sender: TObject);
begin
  Selection(15, 8);
end;

procedure TWdMain.x15y09Click(Sender: TObject);
begin
  Selection(15, 9);
end;

procedure TWdMain.x16y01Click(Sender: TObject);
begin
  Selection(16, 1);
end;

procedure TWdMain.x16y02Click(Sender: TObject);
begin
  Selection(16, 2);
end;

procedure TWdMain.x16y03Click(Sender: TObject);
begin
  Selection(16, 3);
end;

procedure TWdMain.x16y04Click(Sender: TObject);
begin
  Selection(16, 4);
end;

procedure TWdMain.x16y05Click(Sender: TObject);
begin
  Selection(16, 5);
end;

procedure TWdMain.x16y06Click(Sender: TObject);
begin
  Selection(16, 6);
end;

procedure TWdMain.x16y07Click(Sender: TObject);
begin
  Selection(16, 7);
end;

procedure TWdMain.x16y08Click(Sender: TObject);
begin
  Selection(16, 8);
end;

procedure TWdMain.x16y09Click(Sender: TObject);
begin
  Selection(16, 9);
end;

procedure TWdMain.MenuItem2Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Timer1.Enabled := False;
  Ini_Sauve;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  Randomize;
  //-
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';
  //-
  Ini_Lire;
  //-
  Init;
  //Chargement fichiers des Mots
  Data_Chargement;
end;

end.
